local CreateFrame, GetBindingKey, InCombatLockdown, LibStub, MainMenuBar, MultiBarLeft, MultiBarRight, PetActionBarFrame, PetHasActionBar, PetHasActionBarFrame, RegisterStateDriver, ReloadUI, SetAlpha, SlidingActionBarTexture0, SlidingActionBarTexture1, UIParent, idTweaks, idTweaksModule, idTweaksOptions, idTweaksUtils
do
  local _obj_0 = _G
  CreateFrame, GetBindingKey, InCombatLockdown, LibStub, MainMenuBar, MainMenuBar, MultiBarLeft, MultiBarRight, PetActionBarFrame, PetHasActionBar, PetHasActionBarFrame, RegisterStateDriver, ReloadUI, SetAlpha, SlidingActionBarTexture0, SlidingActionBarTexture1, UIParent, idTweaks, idTweaksModule, idTweaksOptions, idTweaksUtils = _obj_0.CreateFrame, _obj_0.GetBindingKey, _obj_0.InCombatLockdown, _obj_0.LibStub, _obj_0.MainMenuBar, _obj_0.MainMenuBar, _obj_0.MultiBarLeft, _obj_0.MultiBarRight, _obj_0.PetActionBarFrame, _obj_0.PetHasActionBar, _obj_0.PetHasActionBarFrame, _obj_0.RegisterStateDriver, _obj_0.ReloadUI, _obj_0.SetAlpha, _obj_0.SlidingActionBarTexture0, _obj_0.SlidingActionBarTexture1, _obj_0.UIParent, _obj_0.idTweaks, _obj_0.idTweaksModule, _obj_0.idTweaksOptions, _obj_0.idTweaksUtils
end
local TL, TC, TR, ML, MC, MR, BL, BC, BR
do
  local _obj_0 = idTweaks.anchor
  TL, TC, TR, ML, MC, MR, BL, BC, BR = _obj_0.TL, _obj_0.TC, _obj_0.TR, _obj_0.ML, _obj_0.MC, _obj_0.MR, _obj_0.BL, _obj_0.BC, _obj_0.BR
end
local list, map
do
  local _obj_0 = idTweaksUtils.table
  list, map = _obj_0.list, _obj_0.map
end
local Option, RangeOption
Option, RangeOption = idTweaksOptions.Option, idTweaksOptions.RangeOption
local LibActionButton = LibStub("LibActionButton-1.0")
local ActionButton
do
  local _class_0
  local _base_0 = {
    get_hotkey_name = function(self)
      return tostring(self.name) .. tostring(self.id) .. ":LeftClick"
    end,
    create_frame = function(self)
      self.frame = LibActionButton:CreateButton(self.id, self.name, self:frame_header({
        outOfRangeColoring = "button",
        tooltip = "enabled",
        showGrid = false,
        colors = {
          range = {
            0.8,
            0.1,
            0.1
          },
          mana = {
            0.5,
            0.5,
            1.0
          }
        },
        hideElements = {
          macro = false,
          hotKey = false,
          equipped = false
        },
        keyBoundTarget = false,
        clickOnDown = false,
        flyoutDirection = "UP"
      }))
      self.frame:SetState(0, "action", self.id)
      return _G[tostring(self.name) .. "Icon"]:SetTexCoord(0.08, 0.92, 0.08, 0.92)
    end,
    create_hotkey = function(self)
      self.hotkey = self.frame:CreateFontString(nil, "OVERLAY", "GameTooltipText")
      self.hotkey:SetFont(self.hotkey:GetFont(), 13, "OUTLINE")
      self.hotkey:SetVertexColor(0.75, 0.75, 0.75)
      self.hotkey:ClearAllPoints()
      self.hotkey:SetPoint(TL, self.frame, TL, 0, 0)
      self.hotkey:SetText(GetBindingKey(self:get_hotkey_name()))
      return self.hotkey:Show()
    end
  }
  _base_0.__index = _base_0
  _class_0 = setmetatable({
    __init = function(self, name, index, id, header)
      self.name = name
      self.index = index
      self.id = id
      self.header = header
      self:create_frame()
      return self:create_hotkey()
    end,
    __base = _base_0,
    __name = "ActionButton"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  ActionButton = _class_0
end
local ActionBar
do
  local _class_0
  local _base_0 = {
    create_frame = function(self)
      self.frame = CreateFrame("Frame", self.name, UIParent)
      local index = 0
      for id = self.first_id, self.last_id do
        self:add_button(index, id)
        index = index + 1
      end
    end,
    create_header = function(self)
      self.header = CreateFrame("Frame", tostring(self.name) .. "Header", UIParent, "SecureHandlerStateTemplate")
      self.header:SetAttribute("_onstate-page", [[      module:SetAttribute("state", newstate)
      control:ChildUpdate("state", newstate)
    ]])
      return RegisterStateDriver(self.header, "page", "0")
    end,
    create_background = function(self)
      self.background = self.frame:CreateTexture(tostring(self.name) .. "Background", "BACKGROUND")
      self.background:SetAllPoints(self.frame)
      return self.background:SetColorTexture(0, 0, 0, 0.5)
    end,
    set_size = function(self)
      local padding, spacing
      do
        local _obj_0 = self.db
        padding, spacing = _obj_0.padding, _obj_0.spacing
      end
      local button_amount = #self.buttons
      local button_width = self.buttons[0]:GetWidth()
      local button_height = self.buttons[0]:GetHeight()
      self.frame:SetWidth(button_width * button_amount + spacing * (button_amount - 1) + padding * 2)
      return self.frame:SetHeight(button_height + padding * 2)
    end,
    add_button = function(self, index, id)
      self.buttons[index] = ActionButton(tostring(self.name) .. "Button" .. tostring(index), index, id, self.header)
    end,
    remove_button = function(self, index)
      self.buttons[index] = nil
    end
  }
  _base_0.__index = _base_0
  _class_0 = setmetatable({
    __init = function(self, name, first_id, last_id)
      self.name = name
      self.first_id = first_id
      self.last_id = last_id
      self.buttons = { }
      self:create_header()
      self:create_frame()
      return self:create_background()
    end,
    __base = _base_0,
    __name = "ActionBar"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  ActionBar = _class_0
end
local ActionBars
do
  local _class_0
  local _parent_0 = idTweaksModule
  local _base_0 = {
    set_options = function(self)
      _class_0.__parent.__base.set_options(self)
      self.options:add_option(RangeOption(self, "padding", "Padding", "Padding", {
        min = 0,
        max = 50,
        step = 1,
        bigStep = 1
      }, { }, 0))
      return self.options:add_option(RangeOption(self, "spacing", "Spacing", "Spacing", {
        min = 0,
        max = 50,
        step = 1,
        bigStep = 1
      }, { }, 0))
    end,
    enable = function(self)
      self:disable_blizzard_bars()
      self:enable_action_bars()
      self:enable_pet_bar()
      self:position_all_bars()
      self:size_all_bars()
      return self:register_keybindings()
    end,
    disable = function(self)
      self:disable_pet_bar()
      self:disable_action_bars()
      return self:enable_blizzard_bars()
    end,
    zoom_button_texture = function(self, texture)
      return texture:SetTexCoord(0.08, 0.92, 0.08, 0.92)
    end,
    set_bar_background = function(self, bar)
      bar.background = bar:CreateTexture(tostring(bar.bar_name) .. "Background", "BACKGROUND")
      bar.background:SetAllPoints(bar)
      return bar.background:SetColorTexture(0, 0, 0, 0.5)
    end,
    get_bar_button_amount = function(self, bar)
      return bar.last_id + 1 - bar.first_id
    end,
    get_button_keybind_name = function(self, bar, button)
      return "idTweaksActionBar" .. tostring(bar.id) .. "Button" .. tostring(button.id) .. ":LeftClick"
    end,
    get_pet_button_keybind_name = function(self, button)
      return "idTweaksActionBarPetButton" .. tostring(button.id) .. ":LeftClick"
    end,
    register_keybindings = function(self)
      print("ActionBars#register_keybindings")
      _G.BINDING_HEADER_IDTBAR1 = "Bar 1"
      _G.BINDING_HEADER_IDTBAR2 = "Bar 2"
      _G.BINDING_HEADER_IDTBAR3 = "Bar 3"
      _G.BINDING_HEADER_IDTBAR4 = "Bar 4"
      _G.BINDING_HEADER_IDTBAR5 = "Bar 5"
      _G.BINDING_HEADER_IDTPETBAR = "Pet Bar"
      local x = 1
      for i = 1, 5 do
        print("bar" .. tostring(i))
        local bar = self.frames["bar" .. tostring(i)]
        if not bar then
          print("NOT FOUND, " .. tostring(i))
        end
        for j = 1, 12 do
          local button = bar["button" .. tostring(j)]
          _G["BINDING_NAME_CLICK " .. tostring(self:get_button_keybind_name(bar, button))] = "Bar " .. tostring(i) .. " Button " .. tostring(j)
          x = x + 1
        end
      end
      for j = 1, 10 do
        local button = self.frames.petbar["button" .. tostring(j)]
        _G["BINDING_NAME_CLICK " .. tostring(self:get_pet_button_keybind_name(button))] = "Pet Bar Button " .. tostring(j)
      end
    end,
    enable_blizzard_bars = function(self)
      print("ActionBars#enable_blizzard_bars")
      MainMenuBar:SetScript("OnShow", nil)
      MainMenuBar:Show()
      MultiBarLeft:SetScript("OnShow", nil)
      MultiBarLeft:Show()
      MultiBarRight:SetScript("OnShow", nil)
      return MultiBarRight:Show()
    end,
    disable_blizzard_bars = function(self)
      print("ActionBars#disable_blizzard_bars")
      MainMenuBar:SetScript("OnShow", MainMenuBar.Hide)
      MainMenuBar:Hide()
      MultiBarLeft:SetScript("OnShow", MultiBarLeft.Hide)
      MultiBarLeft:Hide()
      MultiBarRight:SetScript("OnShow", MultiBarRight.Hide)
      return MultiBarRight:Hide()
    end,
    enable_action_bars = function(self)
      print("ActionBars#enable_action_bars")
      self.frames.bar1 = self.frames.bar1 or self:create_bar("idTweaksActionBar1", 1, 12)
      self.frames.bar2 = self.frames.bar2 or self:create_bar("idTweaksActionBar2", 13, 24)
      self.frames.bar3 = self.frames.bar3 or self:create_bar("idTweaksActionBar3", 25, 36)
      self.frames.bar4 = self.frames.bar4 or self:create_bar("idTweaksActionBar4", 37, 48)
      self.frames.bar5 = self.frames.bar5 or self:create_bar("idTweaksActionBar5", 49, 60)
    end,
    disable_action_bars = function(self)
      print("ActionBars#disable_action_bars")
      self.frames.bar1:ClearAllPoints()
      return self.frames.bar1:SetPoint(BR, UIParent, TL, 0, 0)
    end,
    show_or_hide_pet_bar = function(self)
      print("ActionBars#show_or_hide_pet_bar")
      if InCombatLockdown() then
        return 
      end
      if PetHasActionBar() then
        if not (self.frames.petbar:IsShown()) then
          return self.frames.petbar:Show()
        end
      else
        return self.frames.petbar:Hide()
      end
    end,
    enable_pet_bar = function(self)
      print("ActionBars#enable_pet_bar")
      self.frames.petbar = self.frames.petbar or self:create_pet_bar("idTweaksActionBarPet", 1, 10)
      self.ace_module:RegisterEvent("PLAYER_CONTROL_LOST", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("PLAYER_CONTROL_GAINED", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("PLAYER_FARSIGHT_FOCUS_CHANGED", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("UNIT_PET", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("UNIT_FLAGS", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("PET_BAR_UPDATE", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("PET_BAR_UPDATE_COOLDOWN", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("PET_BAR_SHOWGRID", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("PET_BAR_HIDEGRID", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("PET_BAR_UPDATE_USABLE", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("PET_UI_UPDATE", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("PLAYER_TARGET_CHANGED", function()
        return self.show_or_hide_pet_bar
      end)
      self.ace_module:RegisterEvent("PLAYER_MOUNT_DISPLAY_CHANGED", function()
        return self.show_or_hide_pet_bar
      end)
      return self:show_or_hide_pet_bar()
    end,
    disable_pet_bar = function(self)
      print("ActionBars#disable_pet_bar")
      if not (self.frames.petbar) then
        return 
      end
      self.ace_module:UnregisterEvent("PLAYER_CONTROL_LOST")
      self.ace_module:UnregisterEvent("PLAYER_CONTROL_GAINED")
      self.ace_module:UnregisterEvent("PLAYER_FARSIGHT_FOCUS_CHANGED")
      self.ace_module:UnregisterEvent("UNIT_PET")
      self.ace_module:UnregisterEvent("UNIT_FLAGS")
      self.ace_module:UnregisterEvent("PET_BAR_UPDATE")
      self.ace_module:UnregisterEvent("PET_BAR_UPDATE_COOLDOWN")
      self.ace_module:UnregisterEvent("PET_BAR_SHOWGRID")
      self.ace_module:UnregisterEvent("PET_BAR_HIDEGRID")
      self.ace_module:UnregisterEvent("PET_BAR_UPDATE_USABLE")
      self.ace_module:UnregisterEvent("PET_UI_UPDATE")
      self.ace_module:UnregisterEvent("PLAYER_TARGET_CHANGED")
      self.ace_module:UnregisterEvent("PLAYER_MOUNT_DISPLAY_CHANGED")
      self:show_or_hide_pet_bar()
      PetHasActionBarFrame:EnableMouse("true")
      local _ = {
        SlidingActionBarTexture0 = SetAlpha(1)
      }
      _ = {
        SlidingActionBarTexture1 = SetAlpha(1)
      }
      for i = self.frames.petbar.first_id, self.frames.petbar.last_id do
        local button = _G["PetActionButton" .. tostring(i)]
        button:ClearAllPoints()
        button:SetParent(PetActionBarFrame)
        button:SetPoint(BR, PetActionBarFrame, BL, (65 + ((i - 1) * 38)), 0)
      end
      return self.frames.petbar:Hide()
    end,
    create_button = function(self, bar, i, button_name, frame_header)
      local button = LibActionButton:CreateButton(i, button_name, bar.header, {
        outOfRangeColoring = "button",
        tooltip = "enabled",
        showGrid = false,
        colors = {
          range = {
            0.8,
            0.1,
            0.1
          },
          mana = {
            0.5,
            0.5,
            1.0
          }
        },
        hideElements = {
          macro = false,
          hotKey = false,
          equipped = false
        },
        keyBoundTarget = false,
        clickOnDown = false,
        flyoutDirection = "UP"
      })
      self:zoom_button_texture(_G[tostring(button_name) .. "Icon"])
      self:create_button_hotkey(bar, button)
      return button
    end,
    create_button_hotkey = function(self, bar, button, is_pet_button)
      if is_pet_button == nil then
        is_pet_button = false
      end
      local keybind_name
      if is_pet_button then
        keybind_name = self:get_pet_button_keybind_name(button)
      else
        keybind_name = self:get_button_keybind_name(bar, button)
      end
      local hotkey_text = GetBindingKey(keybind_name)
      button.HotKey:Hide()
      button.Hotkey = button:CreateFontString(nil, "OVERLAY", "GameTooltipText")
      button.Hotkey:SetFont(button.Hotkey:GetFont(), 13, "OUTLINE")
      button.Hotkey:SetVertexColor(0.75, 0.75, 0.75)
      button.Hotkey:ClearAllPoints()
      button.Hotkey:SetPoint(TL, button, TL, 0, 0)
      button.Hotkey:SetText(hotkey_text)
      return button.Hotkey:Show()
    end,
    create_bar = function(self, bar_name, first_id, last_id)
      local bar = CreateFrame("Frame", bar_name, UIParent)
      bar.header = CreateFrame("Frame", tostring(bar_name) .. "Header", UIParent, "SecureHandlerStateTemplate")
      bar.bar_name = bar_name
      bar.button_name = tostring(bar_name) .. "Button"
      bar.first_id = first_id
      bar.last_id = last_id
      self:set_bar_background(bar)
      local j = 1
      for i = bar.first_id, bar.last_id do
        bar["button" .. tostring(j)] = self:create_button(bar, i, tostring(bar.button_name) .. tostring(j))
        j = j + 1
      end
      self:set_bar_actions(bar)
      RegisterStateDriver(bar.header, "page", "0")
      bar.header:SetAttribute("_onstate-page", [[      module:SetAttribute("state", newstate)
      control:ChildUpdate("state", newstate)
    ]])
      return bar
    end,
    create_pet_bar = function(self, bar_name, first_id, last_id)
      local bar = CreateFrame("Frame", bar_name, UIParent)
      bar.header = CreateFrame("Frame", tostring(bar_name) .. "Header", UIParent, "SecureHandlerStateTemplate")
      bar.bar_name = bar_name
      bar.button_name = tostring(bar_name) .. "Button"
      bar.first_id = first_id
      bar.last_id = last_id
      self:set_bar_background(bar)
      local j = 1
      for i = bar.first_id, bar.last_id do
        local button = _G["PetActionButton" .. tostring(i)]
        local button_icon = _G["PetActionButton" .. tostring(i) .. "Icon"]
        local button_border = _G["PetActionButton" .. tostring(i) .. "NormalTexture2"]
        button:ClearAllPoints()
        button:SetParent(bar)
        button:SetWidth(_G.idTweaksActionBar1Button1:GetWidth())
        button:SetHeight(_G.idTweaksActionBar1Button1:GetHeight())
        self:zoom_button_texture(button_icon)
        self:create_button_hotkey(bar, button, true)
        button_border:Hide()
        if button:HasScript("OnUpdate") then
          button:HookScript("OnUpdate", function()
            if self.frames.petbar then
              return button_border:Hide()
            end
          end)
        end
        bar["button" .. tostring(j)] = button
        j = j + 1
      end
      PetActionBarFrame:EnableMouse("false")
      SlidingActionBarTexture0:SetAlpha(0)
      SlidingActionBarTexture1:SetAlpha(0)
      return bar
    end,
    set_bar_actions = function(self, bar)
      for i = 1, self:get_bar_button_amount(bar) do
        local action = bar.first_id - 1 + i
        bar["button" .. tostring(i)]:SetState(0, "action", action)
      end
    end,
    size_bar = function(self, bar)
      local padding, spacing
      do
        local _obj_0 = self.db
        padding, spacing = _obj_0.padding, _obj_0.spacing
      end
      for i = 1, self:get_bar_button_amount(bar) do
        local button = bar["button" .. tostring(i)]
        button:ClearAllPoints()
        if i == 1 then
          button:SetPoint(ML, bar, ML, padding, 0)
        else
          button:SetPoint(ML, bar["button" .. tostring(i - 1)], MR, spacing, 0)
        end
      end
      local button_amount = self:get_bar_button_amount(bar)
      local button_width = bar.button1:GetWidth()
      local button_height = bar.button1:GetHeight()
      bar:SetWidth(button_width * button_amount + spacing * (button_amount - 1) + padding * 2)
      return bar:SetHeight(button_height + padding * 2)
    end,
    size_all_bars = function(self)
      for i = 1, 5 do
        self:size_bar(self.frames["bar" .. tostring(i)])
      end
      return self:size_bar(self.frames.petbar)
    end,
    position_all_bars = function(self)
      local margin
      margin = self.db.margin
      self.frames.bar1:ClearAllPoints()
      self.frames.bar1:SetPoint(BC, UIParent, BC, 0, margin)
      self.frames.bar2:SetPoint(BC, self.frames.bar1, TC, 0, margin)
      self.frames.bar3:SetPoint(BC, self.frames.bar2, TC, 0, margin)
      self.frames.bar4:SetPoint(BC, self.frames.bar3, TC, 0, margin)
      self.frames.bar5:SetPoint(BC, self.frames.bar4, TC, 0, margin)
      return self.frames.petbar:SetPoint(BC, self.frames.bar5, TC, 0, margin)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, addon)
      _class_0.__parent.__init(self, addon, "ActionBars", "AceConsole-3.0", "AceEvent-3.0")
      self.frames = { }
    end,
    __base = _base_0,
    __name = "ActionBars",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ActionBars = _class_0
end
return idTweaks:add_module(ActionBars(idTweaks))
