local AcceptQuest, C_GossipInfo, CompleteQuest, GetNumActiveQuests, GetNumAvailableQuests, GetNumQuestChoices, GetNumQuestLogEntries, GetQuestLogSelection, GetQuestLogTitle, IsAltKeyDown, IsControlKeyDown, IsQuestCompletable, IsShiftKeyDown, QuestFrameCompleteQuestButton, SelectActiveQuest, SelectAvailableQuest, SelectQuestLogEntry, GossipTitleButton1, GossipTitleButton2, ShowQuestComplete, UnitName, idTweaks, idTweaksModule, idTweaksOptions, Option, SelectOption, ToggleOption, Questing
do
  local _obj_0 = _G
  AcceptQuest, C_GossipInfo, CompleteQuest, GetNumActiveQuests, GetNumAvailableQuests, GetNumQuestChoices, GetNumQuestLogEntries, GetQuestLogSelection, GetQuestLogTitle, IsAltKeyDown, IsControlKeyDown, IsQuestCompletable, IsShiftKeyDown, QuestFrameCompleteQuestButton, SelectActiveQuest, SelectAvailableQuest, SelectQuestLogEntry, GossipTitleButton1, GossipTitleButton2, ShowQuestComplete, UnitName, idTweaks, idTweaksModule, idTweaksOptions = _obj_0.AcceptQuest, _obj_0.C_GossipInfo, _obj_0.CompleteQuest, _obj_0.GetNumActiveQuests, _obj_0.GetNumAvailableQuests, _obj_0.GetNumQuestChoices, _obj_0.GetNumQuestLogEntries, _obj_0.GetQuestLogSelection, _obj_0.GetQuestLogTitle, _obj_0.IsAltKeyDown, _obj_0.IsControlKeyDown, _obj_0.IsQuestCompletable, _obj_0.IsShiftKeyDown, _obj_0.QuestFrameCompleteQuestButton, _obj_0.SelectActiveQuest, _obj_0.SelectAvailableQuest, _obj_0.SelectQuestLogEntry, _obj_0.GossipTitleButton1, _obj_0.GossipTitleButton2, _obj_0.ShowQuestComplete, _obj_0.UnitName, _obj_0.idTweaks, _obj_0.idTweaksModule, _obj_0.idTweaksOptions
end
do
  local _obj_0 = idTweaksOptions
  Option, SelectOption, ToggleOption = _obj_0.Option, _obj_0.SelectOption, _obj_0.ToggleOption
end
do
  local _class_0
  local _parent_0 = idTweaksModule
  local _base_0 = {
    set_options = function(self)
      _class_0.__parent.__base.set_options(self)
      self.options:add_option(SelectOption(self, "pause_key", "Pause Key", "While you hold this key nothing will happen", {
        values = {
          shift = "Shift",
          control = "Control",
          alt = "Alt"
        }
      }, { }, "shift"))
      self.options:add_option(ToggleOption(self, "accept_quests", "Accept Quests", "Accept quests"))
      self.options:add_option(ToggleOption(self, "complete_quests", "Complete Quests", "Automatically complete quests unless when offered a choice of rewards"))
      return self.options:add_option(ToggleOption(self, "complete_gossip", "Complete Gossip", "When the gossip window has one option, use it"))
    end,
    enable = function(self)
      self.ace_module:RegisterEvent("GOSSIP_SHOW", function()
        if not (self:should_automate()) then
          return 
        end
        return self:automate_gossip_window()
      end)
      self.ace_module:RegisterEvent("QUEST_AUTOCOMPLETE", function(_, quest_id)
        if not (self:should_automate()) then
          return 
        end
        if not (self:should_complete()) then
          return 
        end
        return self:autocomplete_quest(quest_id)
      end)
      self.ace_module:RegisterEvent("QUEST_COMPLETE", function()
        if not (self:should_automate()) then
          return 
        end
        if not (self:should_complete()) then
          return 
        end
        return self:complete_quest()
      end)
      self.ace_module:RegisterEvent("QUEST_DETAIL", function()
        if not (self:should_automate()) then
          return 
        end
        if not (self:should_accept()) then
          return 
        end
        return self:accept_quest()
      end)
      self.ace_module:RegisterEvent("QUEST_GREETING", function()
        if not (self:should_automate()) then
          return 
        end
        return self:automate_gossip_window()
      end)
      self.ace_module:RegisterEvent("QUEST_LOG_UPDATE", function()
        if not (idTweaks:is_bc()) then
          return 
        end
        if not (self:should_automate()) then
          return 
        end
        self:index_quests()
        return SelectQuestLogEntry(GetQuestLogSelection())
      end)
      return self.ace_module:RegisterEvent("QUEST_PROGRESS", function()
        if not (self:should_automate()) then
          return 
        end
        if not (self:should_complete()) then
          return 
        end
        return self:progress_quest()
      end)
    end,
    disable = function(self)
      self.ace_module:UnregisterEvent("GOSSIP_SHOW")
      self.ace_module:UnregisterEvent("QUEST_AUTOCOMPLETE")
      self.ace_module:UnregisterEvent("QUEST_COMPLETE")
      self.ace_module:UnregisterEvent("QUEST_DETAIL")
      self.ace_module:UnregisterEvent("QUEST_GREETING")
      self.ace_module:UnregisterEvent("QUEST_LOG_UPDATE")
      return self.ace_module:UnregisterEvent("QUEST_PROGRESS")
    end,
    should_automate = function(self)
      local output = true
      local key = self.db.pause_key
      if key == "shift" then
        if IsShiftKeyDown() then
          output = false
        end
      end
      if key == "control" then
        if IsControlKeyDown() then
          output = false
        end
      end
      if key == "alt" then
        if IsAltKeyDown() then
          output = false
        end
      end
      return output
    end,
    should_accept = function(self)
      return self.db.accept_quests
    end,
    should_complete = function(self)
      return self.db.complete_quests
    end,
    strip_text = function(self, text)
      if not (text) then
        return 
      end
      text = text:gsub("|c%x%x%x%x%x%x%x%x(.-)|r", "%1")
      text = text:gsub("%[.*%]%s*", "")
      text = text:gsub("(.+) %(.+%)", "%1")
      text = text:trim()
      return text
    end,
    index_quests = function(self)
      self.completed_quests = { }
      self.incomplete_quests = { }
      local num_entries = GetNumQuestLogEntries()
      if num_entries > 1 then
        for i = 1, num_entries do
          SelectQuestLogEntry(i)
          local title, _, is_complete
          title, _, _, _, _, is_complete = GetQuestLogTitle(i)
          if title then
            if is_complete then
              self.completed_quests[title] = true
            else
              self.incomplete_quests[title] = true
            end
          end
        end
      end
    end,
    accept_quest = function(self)
      return AcceptQuest()
    end,
    autocomplete_quest = function(self, quest_id)
      return ShowQuestComplete(quest_id)
    end,
    progress_quest = function(self)
      if not (self:should_complete()) then
        return 
      end
      if IsQuestCompletable() then
        return CompleteQuest()
      end
    end,
    complete_quest = function(self)
      if GetNumQuestChoices() <= 1 then
        return QuestFrameCompleteQuestButton:Click()
      end
    end,
    automate_gossip_window = function(self)
      if idTweaks:is_bc() then
        if GossipTitleButton1:IsVisible() and (GossipTitleButton1.type == "Gossip" or GossipTitleButton1.type == "Active") and not GossipTitleButton2:IsVisible() then
          GossipTitleButton1:Click()
        end
        for i = 32, 1, -1 do
          local button = _G["QuestTitleButton" .. tostring(i)]
          if button and button:IsVisible() then
            local text = self:strip_text(button:GetText())
            if self.completed_quests[text] and self:should_complete() then
              button:Click()
            elseif self.incomplete_quests[text] and self:should_accept() then
              button:Click()
            end
          end
        end
        for i = 32, 1, -1 do
          local button = _G["GossipTitleButton" .. tostring(i)]
          if button and button:IsVisible() then
            local text = self:strip_text(button:GetText())
            if self.completed_quests[text] and self:should_complete() then
              button:Click()
            elseif self.incomplete_quests[text] and self:should_accept() then
              button:Click()
            end
          end
        end
      end
      if idTweaks:is_retail() then
        local num_active_quests = C_GossipInfo.GetNumActiveQuests()
        if num_active_quests > 0 then
          for i = 1, num_active_quests do
            C_GossipInfo.SelectActiveQuest(i)
          end
        end
        local num_available_quests = C_GossipInfo.GetNumAvailableQuests()
        if num_available_quests > 0 then
          for i = 1, num_available_quests do
            C_GossipInfo.SelectAvailableQuest(i)
          end
        end
        num_available_quests = GetNumAvailableQuests()
        if num_available_quests > 0 then
          for i = 1, num_available_quests do
            SelectAvailableQuest(i)
          end
        end
        num_active_quests = GetNumActiveQuests()
        if num_active_quests > 0 then
          for i = 1, num_active_quests do
            SelectActiveQuest(i)
          end
        end
        local num_gossips = C_GossipInfo.GetNumOptions()
        if num_gossips == 1 then
          return C_GossipInfo.SelectOption(1)
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, addon)
      _class_0.__parent.__init(self, addon, "Questing", "AceConsole-3.0", "AceEvent-3.0")
      self.completed_quests = { }
      self.incomplete_quests = { }
    end,
    __base = _base_0,
    __name = "Questing",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Questing = _class_0
end
return idTweaks:add_module(Questing(idTweaks))
